commit:     8ec0b6e52f2bf715dda551c6c72d7c48914da6bb
Author:     Z. Liu <zhixu.liu <AT> gmail <DOT> com>
AuthorDate: Tue May  6 16:35:27 2025 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Sun May 11 00:33:08 2025 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=8ec0b6e5

sys-process/runit: fix build errors/warnings by gcc 15 & clang 19

Signed-off-by: Z. Liu <zhixu.liu <AT> gmail.com>
Part-of: https://github.com/gentoo/gentoo/pull/41977
Closes: https://github.com/gentoo/gentoo/pull/41977
Signed-off-by: Sam James <sam <AT> gentoo.org>

 sys-process/runit/Manifest              |   1 +
 sys-process/runit/runit-2.2.0-r2.ebuild | 168 ++++++++++++++++++++++++++++++++
 2 files changed, 169 insertions(+)

diff --git a/sys-process/runit/Manifest b/sys-process/runit/Manifest
index 72d3251835d4..be29c1097692 100644
--- a/sys-process/runit/Manifest
+++ b/sys-process/runit/Manifest
@@ -1,3 +1,4 @@
 DIST runit-2.1.2-patches-20240905.tar.xz 20104 BLAKE2B 
ebdc123ea722f223eec3ad5d63a4c3e7c4ef771592796f2d5624f4308c1d08eede7d4fa0c2a9fdd23dbf74be6135c69bae495d89cf582678b9308b1d146ef883
 SHA512 
15c5acd865ecc7f6c3b9b1fc94dc00bc44ceefd1c0ca6b53963d94338712cd716ad961826cccd065029ee67464dc288428952004ffcec3a1a97a058696f4f233
 DIST runit-2.1.2.tar.gz 110916 BLAKE2B 
101e514aeed282685ebe636f401ca6f94d157281d08a3ac487340aebe945b82d2ee01d41e9917446f4ebd7b27fe9fd18ba4ad55739ab1b62a0e59e1c438b55e9
 SHA512 
a18773ebf1aa22305dd89ed67363165b9fcf86c192b2be4e268d08005dd82d51265160c637abe072f2f2e378c4b315a75bd3d3e602c3e75bdd451a3b0190f8cf
+DIST runit-2.2.0-patches-20250506.tar.xz 12528 BLAKE2B 
02349bc5b0566f4acd44768e1ed0139e53fdb62a0fa6c3e083462f1e212890afa3eb33af60b7eb787801c0a9780416b8e2ce807ec191455881759c2924bf06a0
 SHA512 
959c539d2ef265baab4e334f35b386d0cb0a2896faea3aba9239f090ac7fdb5a714e2d4408d63d826ecf8977ce4eaf8dacabba849e9383560182a4163045acaf
 DIST runit-2.2.0.tar.gz 111395 BLAKE2B 
46a4b91cf180694a69ade3cabaddb35a89db516ef75e9fc69b8091a5c3570079796b8a4cf227edc74938e182833edcce7af40f01d5cb1b4032993fb094459ede
 SHA512 
cedfe6d3505aca754ff11d791055f023a7be42e2fbdd2e4964b3460692474371a72363cf181ae2dfae5c02df45ebf568cdab72a5000d1b48e26e12217d4e9a3d

diff --git a/sys-process/runit/runit-2.2.0-r2.ebuild 
b/sys-process/runit/runit-2.2.0-r2.ebuild
new file mode 100644
index 000000000000..062633c5503c
--- /dev/null
+++ b/sys-process/runit/runit-2.2.0-r2.ebuild
@@ -0,0 +1,168 @@
+# Copyright 1999-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+inherit toolchain-funcs flag-o-matic
+
+DESCRIPTION="A UNIX init scheme with service supervision"
+HOMEPAGE="https://smarden.org/runit/";
+PATCH_VER=20250506
+SRC_URI="
+       https://smarden.org/runit/${P}.tar.gz
+       
https://github.com/clan/runit/releases/download/${PF}/${P}-patches-${PATCH_VER}.tar.xz
+"
+S=${WORKDIR}/admin/${P}/src
+
+LICENSE="BSD"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~m68k ~mips ~ppc ~ppc64 ~s390 ~sparc 
~x86"
+IUSE="+scripts split-usr static"
+
+src_unpack() {
+       unpack ${P}.tar.gz
+       unpack ${P}-patches-${PATCH_VER}.tar.xz
+}
+
+src_prepare() {
+       default
+
+       cd "${S}" || die
+
+       eapply -p2 "${WORKDIR}"/patches
+
+       # We either build everything or nothing static
+       sed -i -e 's:-static: :' Makefile || die
+
+       # see https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=726008
+       [[ ${COMPILER} == "diet" ]] &&
+               use ppc &&
+               filter-flags "-mpowerpc-gpopt"
+}
+
+src_configure() {
+       use static && append-ldflags -static
+
+       echo "$(tc-getCC) ${CFLAGS}"  > conf-cc || die
+       echo "$(tc-getCC) ${LDFLAGS}" > conf-ld || die
+       sed -i -e "s:ar cr:$(tc-getAR) cr:" print-ar.sh || die
+       sed -i -e "s:ranlib :$(tc-getRANLIB) :" print-ar.sh || die
+}
+
+src_install() {
+       dobin $(<../package/commands)
+       dodir /sbin
+       mv "${ED}"/usr/bin/{runit-init,runit,utmpset} "${ED}"/sbin/ || die 
"dosbin"
+       if use split-usr ; then
+               dosym ../etc/runit/2 /sbin/runsvdir-start
+       else
+               dosym ../../etc/runit/2 /sbin/runsvdir-start
+       fi
+
+       DOCS=( ../package/{CHANGES,README,THANKS} )
+       HTML_DOCS=( ../doc/*.html )
+       einstalldocs
+       doman ../man/*.[18]
+
+       if use scripts ; then
+               exeinto /etc/runit
+               doexe "${FILESDIR}"/ctrlaltdel
+               newexe "${FILESDIR}"/1-r2 1
+               newexe "${FILESDIR}"/2-r1 2
+               newexe "${FILESDIR}"/3-r2 3
+               doexe "${FILESDIR}"/rc.sh
+               insinto /etc/runit/rc
+               doins "${FILESDIR}"/1.openrc.example
+               doins "${FILESDIR}"/3.openrc.example
+       fi
+
+       dodir /etc/sv
+       for tty in tty1 tty2 tty3 tty4 tty5 tty6; do
+               exeinto /etc/sv/getty-$tty/
+               newexe "${FILESDIR}"/finish.getty finish
+               newexe "${FILESDIR}"/run.getty run
+               for script in finish run; do
+                       sed -i -e "s:TTY:${tty}:g" 
"${ED}"/etc/sv/getty-$tty/$script
+               done
+       done
+
+       # make sv command work
+       newenvd - 20runit <<- EOF
+               #/etc/env.d/20runit
+               SVDIR="/etc/service/"
+       EOF
+}
+
+default_config() {
+       local sv="${EROOT}"/etc/sv
+       local service="${EROOT}"/etc/service
+       mkdir -p "${service}" || die
+       for x in tty1 tty2 tty3 tty4 tty5 tty6; do
+               ln -sf "${sv}"/getty-$x "${service}"/getty-$x || die
+       done
+       einfo "The links to services runit will supervise are installed"
+       einfo "in $service."
+       einfo "If you need multiple runlevels, please see the documentation"
+       einfo "for how to set them up."
+       einfo
+}
+
+migrate_from_211() {
+       # Create /etc/service and /var/service if requested
+       if [[ -e "${T}"/make_var_service ]]; then
+               ln -sf "${EROOT}"/etc/runit/runsvdir/current 
"${EROOT}"/etc/service || die
+               ln -sf "${EROOT}"/etc/runit/runsvdir/current 
"${EROOT}"/var/service || die
+       fi
+       if [[ -d "${T}"/runsvdir ]]; then
+               cp -a "${T}"/runsvdir "${EROOT}"/etc/runit || die
+       fi
+       return 0
+}
+
+pkg_preinst() {
+       if  has_version '<sys-process/runit-2.1.2'; then
+               pre_212=yes
+       fi
+}
+
+pkg_postinst() {
+       if [[ -z ${REPLACING_VERSIONS} ]]; then
+               default_config
+       elif [[ -n ${pre_212} ]]; then
+               migrate_from_211
+       fi
+
+       if use scripts; then
+               ewarn "To make sure sv works correctly in your currently open"
+               ewarn "shells, please run the following command:"
+               ewarn
+               ewarn "source /etc/profile"
+               ewarn
+               ewarn "Currently, no task(s) will run in stage 1 & 3, you're on 
your own"
+               ewarn "to put script(s) into /etc/runit/rc/, please see 
/etc/runit/rc.sh"
+               ewarn "for name in different stages."
+       else
+               ewarn "This build with USE=\"-scripts\" doesn\'t include any 
boot scripts"
+               ewarn "into /etc/runit, you are on your own to put the scripts."
+               ewarn "Also, /sbin/runsvdir-start is a broken symlink to 
/etc/runit/2, you will"
+               ewarn "need to create script /etc/runit/2 before use it."
+       fi
+
+       if [[ -L "${EROOT}"/var/service ]]; then
+               ewarn "Once this version of runit is active, please remove the"
+               ewarn "compatibility symbolic link at ${EROOT}/var/service"
+               ewarn "The correct path now is ${EROOT}/etc/service"
+               ewarn
+       fi
+
+       if [[ -L "${EROOT}"/etc/runit/runsvdir/all ]]; then
+               ewarn "${EROOT}/etc/runit/runsvdir/all has moved to"
+               ewarn "${EROOT}/etc/sv."
+               ewarn "Any symbolic links under ${EROOT}/etc/runit/runsvdir"
+               ewarn "which point to services through ../all should be updated 
to"
+               ewarn "point to them through ${EROOT}/etc/sv."
+               ewarn "Once that is done, ${EROOT}/etc/runit/runsvdir/all 
should be"
+               ewarn "removed."
+               ewarn
+       fi
+}

Reply via email to